<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../common/content-types';
import { getPageMetadata } from '~/common/meta';
import { FeaturesComparisonList } from '~/components/pricing/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';
import { FooterEditLinkMixin } from '~/mixins';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  name: 'Pricing',
  components: {
    FeaturesComparisonList,
    NextStepAlt,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ i18n }) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        locale: convertToCaseSensitiveLocale(i18n.locale),
        'fields.slug': 'pricing/feature-comparison',
        include: 10,
      });

      const spaceId = response.items[0].sys.space.sys.id;
      const entryId = response.items[0].sys.id;
      const seo = response.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seo.ogTitle,
        ogTitle: seo.ogTitle,
        description: seo.description,
        ogDescription: seo.ogDescription,
      };

      const data = response.items[0].fields.pageContent;

      return { data, metadata, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <SlpRow>
    <SlpColumn :cols="12">
      <FeaturesComparisonList :data="data[0].fields" />
      <NextStepAlt />
    </SlpColumn>
  </SlpRow>
</template>
